You are given a string, S, and a list of words, L, that are all of the same length. Find all starting indices of substring(s) in S that is a concatenation of each word in L exactly once and without any intervening characters.
For example, given:
S: "barfoothefoobarman"
L: ["foo", "bar"]
You should return the indices: [0,9]
.
(order does not matter).
这么说吧。我是通过比较作的。所以为了减少寻找时间,用了HashMap来做,其key是L中对应的字符串,其Value是该字符串出现的次数
然后通过2个指针来做
因为L的每个长度一样,所以我们可以对S进行截断比较,如果找到,就把对应的temp中的值减一或者是直接删除掉(这里需要一个temp来保存HashMap中的数据,每进行一次循环比较,就重新赋值一次。原因就是要删除temp中的数据,保证答案的正确性)
最后如果次数达到了L的长度,就表示找到了.
但是我用这个代码提交,有的时候会报超时,有的时候却AC。。无语..
估计是哪里写不好...还要努力
public class Solution { public ArrayList<Integer> findSubstring(String S, String[] L) { ArrayList<Integer> result = new ArrayList<Integer>(); HashMap<String,Integer> map = new HashMap<String, Integer>(); if(L.length == 0) return result; for(int i = 0 ; i<L.length; i ++) { if(map.containsKey(L[i])) { map.put(L[i], map.get(L[i])+1); } else { map.put(L[i], 1); } } int sLength = S.length(); int eachLength = L[0].length(); int numL = L.length; for(int i =0 ; i <= sLength-eachLength*numL;i++) { boolean tag = false; int times = 0; for(int j = i; j < i + eachLength*numL;j+=eachLength) { String sub = S.substring(j, j+eachLength); if (map.containsKey(sub)) { if(map.get(sub)>1) { map.put(sub, map.get(sub)-1); } times++; if(times == numL) { tag = true; } } } if(tag == true) { result.add(i); } } return result; } }
LeetCode|Substring with Concatenation of All Words,布布扣,bubuko.com
LeetCode|Substring with Concatenation of All Words
原文:http://blog.csdn.net/hwb1992/article/details/24364625